/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fun>
#include <hamsandwich>
#include <fakemeta>
#include <fakemeta_util>

#define PLUGIN "[JB]Dragon knife "
#define VERSION "1.0"
#define AUTHOR "serg.elit"

new bool:g_Dragon[33]
new Round[33]

new const g_Dragon_viewmodel[] = { "models/dragon/v_strong_dragon.mdl" }
new const g_Dragon_weaponmodel[] = { "models/dragon/p_strong_dragon.mdl" }

public plugin_init() {
	
	register_plugin(PLUGIN, VERSION, AUTHOR)
        register_clcmd("knife_dragon", "GiveDragon")

	RegisterHam(Ham_Spawn, "player", "Spawn_player", 1)
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage")
	register_logevent("round_start", 2, "0=World triggered", "1=Round_Start")
	register_event( "CurWeapon", "WeaponChange", "be", "1=1" )
	register_forward(FM_EmitSound, "fw_EmitSound")
        RegisterHam(Ham_Player_PreThink, "player", "PlayerPreThink")
}

public PlayerPreThink(id)
{
   if(!is_user_alive(id))
      return;

   if (g_Dragon[id])
   {
        set_user_gravity( id, 0.5 )
        set_user_maxspeed(id, 400.0)
   }
}

public plugin_precache()
{
	precache_model( "models/dragon/v_strong_dragon.mdl" )
	precache_model( "models/dragon/p_strong_dragon.mdl" )
	precache_sound( "weapons/dragon_slash1.wav" )
	precache_sound( "weapons/dragon_deploy1.wav" )
	precache_sound( "weapons/dragon_hitwall1.wav" )
	precache_sound( "weapons/dragon_hit2.wav" )
	precache_sound( "weapons/dragon_stab.wav" )
}
	

public WeaponChange(id)
{
	if (read_data(1) != 1)
		return
	
	static weapon;
	weapon = read_data(2);
	
	if (weapon == CSW_KNIFE && g_Dragon[id])
	{
		set_pev(id, pev_viewmodel2, g_Dragon_viewmodel)
		set_pev(id, pev_weaponmodel2, g_Dragon_weaponmodel)
                set_user_gravity( id, 0.5 );
	}
}

public TakeDamage(victim, inflictor, attacker, Float:damage, damage_type)
{
	if (victim == attacker || !is_user_connected(attacker))
		return HAM_IGNORED;
	
	if (get_user_weapon(attacker) == CSW_KNIFE && !IsGrenade(inflictor) && g_Dragon[attacker])
	{
		SetHamParamFloat(4, 60.0)
	}
	if (get_user_team(victim) == get_user_team(attacker) && IsGrenade(inflictor))
	{
		return HAM_SUPERCEDE
	}
	
	return HAM_IGNORED
}

public fw_EmitSound(id, channel, const sample[], Float:volume, Float:attn, flags, pitch)
{
	if (!is_user_connected(id))
		return FMRES_IGNORED;
		
	if (g_Dragon[id] && equal(sample[8], "kni", 3))
	{
		volume = 0.6;
		
		if (equal(sample[14], "sla", 3))
		{
			engfunc(EngFunc_EmitSound, id, channel, "weapons/dragon_slash1.wav", volume, attn, flags, pitch);
			return FMRES_SUPERCEDE;
		}
		if(equal(sample,"weapons/knife_deploy1.wav"))
		{
			engfunc(EngFunc_EmitSound, id, channel, "weapons/dragon_deploy1.wav", volume, attn, flags, pitch);
			return FMRES_SUPERCEDE;
		}
		if (equal(sample[14], "hit", 3))
		{
			if (sample[17] == 'w') 
			{
				engfunc(EngFunc_EmitSound, id, channel,"weapons/dragon_hitwall1.wav", volume, attn, flags, pitch);
				return FMRES_SUPERCEDE;
			}
			else 
			{
				engfunc(EngFunc_EmitSound, id, channel, "weapons/dragon_hit2.wav", volume, attn, flags, pitch);
				return FMRES_SUPERCEDE;
			}
		}
		if (equal(sample[14], "sta", 3)) 
		{
			engfunc(EngFunc_EmitSound, id, channel, "weapons/dragon_stab.wav", volume, attn, flags, pitch);
			return FMRES_SUPERCEDE;
		}
	}
	return FMRES_IGNORED;
}

public Spawn_player(id)
{
		g_Dragon[id] = false
}

public GiveDragon(id)
{
	if(get_user_flags(id) & ADMIN_RESERVATION)
	{
		engclient_cmd(id, "weapon_knife")
		set_pev(id, pev_viewmodel2, g_Dragon_viewmodel)
		set_pev(id, pev_weaponmodel2, g_Dragon_weaponmodel)
		g_Dragon[id] = true
                set_user_gravity( id, 0.5 );
                set_user_maxspeed(id, 400.0)
	}
}  


public round_start()
{
	for(new id = 0; id < 33; id++)
	{
		if(Round[id] > 0 && is_user_alive(id))
		{
			Round[id] -= 1
		}
	}
}

bool:IsGrenade(i_Inflictor)
{
	static s_Classname[8];
	pev(i_Inflictor, pev_classname, s_Classname, charsmax(s_Classname));
        
	return equal(s_Classname, "grenade") ? true : false;
}